package com.infoepoch.pms.agent.platform.agent.domain.irepository;

import com.infoepoch.pms.agent.platform.agent.domain.AgentField;

import java.util.List;
import java.util.Optional;

/**
 * @author jiangyz
 * @date 2026/4/17 16:51
 * 智能体字段定义仓储接口
 */
public interface IAgentFieldRepository {

    /**
     * 新增
     * @param: [entity]
     */
    boolean insert(AgentField entity);

    /**
     * 更新
     * @param: [entity]
     */
    boolean update(AgentField entity);

    /**
     * 批量新增
     * @param: [entitys]
     */
    int[] batchInsert(List<AgentField> entitys);

    /**
     * 批量更新
     * @param: [entitys]
     */
    int[] batchUpdate(List<AgentField> entitys);

    /**
     * 删除
     * @param: [id]
     */
    boolean delete(String id);

    // region select

    /**
     * 根据Id查询
     * @param: [id]
     */
    AgentField selectById(String id);

    /**
     * 根据查询条件查询单个对象
     * @param: [criteria]
     */
    AgentField selectOneByCriteria(AgentFieldCriteria criteria);

    /**
     * 根据查询条件查询对象集合
     * @param: [criteria]
     */
    List<AgentField> selectByCriteria(AgentFieldCriteria criteria);

    /**
     * 根据查询条件分页查询对象结合
     * @param: [criteria, pageNum, pageSize]
     */
    List<AgentField> selectCriteriaByPage(AgentFieldCriteria criteria, int pageNum, int pageSize);

    /**
     * 根据条件查询对象总记录数
     * @param: [criteria]
     */
    Integer selectCountByCriteria(AgentFieldCriteria criteria);

    // endregion

    Optional<AgentField> findById(String id);

    AgentField save(AgentField entity);

    List<AgentField> findAllByAgentIdOrderBySortOrderAsc(String agentId);

    void deleteByAgentId(String agentId);
}
